<template>
  <div class="sw-gs-offcanvas">
    <SfSidebar :visible="isSidebarOpen"
              position="right"
               class="sf-sidebar--right"
               @close="toggleSidebar(false)"
               :persistent="true"
               :overlay="false">
      <template #bar>
        <div class="sw-gs-offcanvas-topbar-spaceholder smartphone-only"></div>
      </template>
      <template #circle-icon="{ close, button }">
        <div class="sw-gs-offcanvas-close-btn-container">
          <SfCircleIcon v-if="button"
                        icon-size="12px"
                        aria-label="Close sidebar"
                        icon="cross"
                        class="sw-gs-offcanvas-close-btn sf-sidebar__circle-icon"
                        @click="close">
            <SwGsIconClose class="color-white size-sm"/>
          </SfCircleIcon>
        </div>
      </template>

      <transition name="fade" mode="out-in">
        <SfTabs :openTab="activeTab">
          <SfTab :title="$t('Last seen products')">
            <template #title="{ tabClick, isActive, title }">
              <SfButton :aria-pressed="isActive.toString()"
                        class="sw-gs-tabs-title-first sf-button--pure sf-tabs__title"
                        :class="{ 'is-active': isActive }"
                        @click="tabClick">
                <SwGsIconLastSeen class="color-dark-secondary size-sm"/>
                <span class="sw-gs-tab-name">{{ title }}</span>
              </SfButton>
            </template>

            <SwGsOffcanvasLastSeen/>
          </SfTab>
          <SfTab :title="$t('Like list')">
            <template #title="{ tabClick, isActive, title }">
              <SfButton :aria-pressed="isActive.toString()"
                        class="sw-gs-tabs-title-second sf-button--pure sf-tabs__title"
                        :class="{ 'is-active': isActive }"
                        @click="tabClick">
                <SwGsIconThumbsUp class="color-dark-secondary size-sm"/>
                <span class="sw-gs-tab-name">{{ title }}</span>
              </SfButton>
            </template>

            <SwGsOffcanvasLikeList/>
          </SfTab>
          <SfTab :title="$t('Cart')">
            <template #title="{ tabClick, isActive, title }">
              <SfButton :aria-pressed="isActive.toString()"
                        class="sw-gs-tabs-title-third sf-button--pure sf-tabs__title"
                        :class="{ 'is-active': isActive }"
                        @click="tabClick">
                <SwGsIconCart class="color-dark-secondary size-sm"/>
                <span class="sw-gs-tab-name">{{ title }}</span>
              </SfButton>
            </template>

            <SwGsOffcanvasCart/>
          </SfTab>
        </SfTabs>
      </transition>
    </SfSidebar>
  </div>
</template>

<script lang="ts">
  import {
    SfSidebar,
    SfTabs,
    SfButton,
    SfCircleIcon
  } from "@storefront-ui/vue"
  import { useUIState } from "@shopware-pwa/composables"
  import { useTabsUIState } from "../../logic/composables/useTabsUIState"
  import SwGsOffcanvasLikeList from "./SwGsOffcanvasLikeList.vue"
  import SwGsOffcanvasCart from "./SwGsOffcanvasCart.vue"
  import SwGsOffcanvasLastSeen from "./SwGsOffcanvasLastSeen.vue";
  import { computed, onMounted, ref } from "@vue/composition-api"
  import { SwGsIconCart, SwGsIconLastSeen, SwGsIconThumbsUp, SwGsIconClose } from "../icons";

  export default {
    name: "SwGsOffcanvas",
    components: {
      SwGsOffcanvasLastSeen,
      SfSidebar,
      SwGsOffcanvasLikeList,
      SwGsOffcanvasCart,
      SfTabs,
      SfButton,
      SfCircleIcon,
      SwGsIconCart,
      SwGsIconLastSeen,
      SwGsIconThumbsUp,
      SwGsIconClose
    },
    setup() {
      const { isOpen: isSidebarOpen, switchState: toggleSidebarState } = useUIState({ stateName: "GS_OFFCANVAS_SIDEBAR_STATE" })
      const { activeTab } = useTabsUIState({ stateName: "GS_OFFCANVAS_TABS_STATE" })

      // Component is lazy loaded so to allow animation on first load it needs to be done after it is mounted
      const isComponentMounted = ref(false)

      onMounted(async () => {
        isComponentMounted.value = true
      })

      const sidebarState = computed(
        () => isSidebarOpen.value && isComponentMounted.value
      )

      return {
        isSidebarOpen: sidebarState,
        toggleSidebar: toggleSidebarState,
        activeTab
      }
    },

    watch: {
      isSidebarOpen(val) {
        if (!val) {
          document.body.style.overflow = "auto"
        }
      },
    },
  }
</script>
<style lang="scss" scoped>
  @import "@/assets/scss/variables";
  @import "~@storefront-ui/shared/styles/components/organisms/SfSidebar.scss";
  @import "~@storefront-ui/shared/styles/components/organisms/SfTabs.scss";

  ::v-deep .sf-sidebar--right {
    @include for-desktop {
      --sidebar-left: auto;
      --sidebar-right: 0;
      --sidebar-top-padding: var(--spacer-base);
      --sidebar-circle-icon-top: var(--spacer-sm);
      --sidebar-content-padding: var(--spacer-base);
      --sidebar-circle-icon-transform: translate3d(-25%, 0, 0);
    }
  }

  ::v-deep .sf-overlay {
    z-index: var(--sidebar-overlay-z-index);
  }

  ::v-deep .sf-sidebar__aside {
    height: auto;
    z-index: var(--offcanvas-z-index);
    left: auto;
    right: 0;
    transition: width 0.3s ease-in-out;
    max-width: 100%;
    --sidebar-width: var(--last-seen-width-maximized-mobile);

    @include for-tablet {
      --sidebar-width: var(--last-seen-width-maximized);
    }
  }

  .sw-gs-offcanvas-topbar-spaceholder {
    display: none;
  }

  .sw-gs-offcanvas-close-btn-container {
    display: flex;
    justify-content: flex-end;
    background: var(--c-white);
    width: 100%;
  }

  .sw-gs-offcanvas-close-btn.sf-sidebar__circle-icon {
    --icon-color: var(--c-white);
    --button-padding: 0;
    --icon-size: 1.5rem;
    --button-size: 3.25rem;
    --button-background: var(--c-primary);
    --button-border-radius: 100%;
    --button-box-shadow: 0 0 0 0.3125rem var(--c-primary);
    position: absolute;
    top: auto;
    bottom: 20px;
    right: 45px;
    left: auto;
    display: flex;
    height: 52px;

    @include for-desktop {
      left: -52px;
      top: var(--spacer-xl);
      right: auto;
      transform: translate3d(50%, 0, 0);
      margin: 0;
    }
  }

  ::v-deep .sf-sidebar__content {
    padding: 0; // moving padding to divs inside
  }

  ::v-deep .sf-tabs {
    --tabs-title-z-index: var(--helper-lay-over-sibling-z-index);
    --tabs-content-order: 1;
    --tabs-title-flex: 0 0 auto;
    --tabs-title-margin: 0 var(--spacer-lg) -2px 0;
    --tabs-title-padding: var(--spacer-xs) 0;
    --tabs-title-color: var(--c-text-muted);
    --tabs-title-font-size: var(--h4-font-size);
    --tabs-content-tab-padding: var(--spacer-xl) 0;
    --tabs-chevron-display: none;

    &__content__tab {
      padding: 24px;
    }

    &__title {
      font-size: 18px;
      margin: 0 auto;
      padding: 16px 0;

      .sw-gs-tab-name {
        display: none;
      }

      &.is-active {
        --tabs-title-border-width: 0 0 2px 0;
        --tabs-title-border-color: var(--c-primary);
        --tabs-title-color: var(--c-text);

        & + .sf-tabs__content {
          --tabs-content-border-width: 2px 0 0 0;
        }

        .sf-icon {
          margin-right: 12px;
        }

        .sw-gs-tab-name {
          display: inline;
        }
      }

      &:hover {
        --tabs-title-color: var(--c-text);
      }
    }
  }
</style>
